//*----------------------------------------------------------------------------
// TASTENPRELLEN.H
//*----------------------------------------------------------------------------

#include "tools.h"

 void Key_service (void)
 {
  static uint8_t ct0, ct1, rpt;
  uint8_t i;
  i = key_state ^ ~KEY_PIN;		// key changed ?
  ct0 = ~( ct0 & i );			// reset or count ct0
  ct1 = ct0 ^ (ct1 & i);		// reset or count ct1
  i &= ct0 & ct1;			// count until roll over ?
  key_state ^= i;			// then toggle debounced state
  key_press |= key_state & i;		// 0->1: key press detect
  if( (key_state & REPEAT_MASK) == 0 )	// check repeat function
     rpt = REPEAT_START;		// start delay
  if( --rpt == 0 ){
    rpt = REPEAT_NEXT;			// repeat delay
    key_rpt |= key_state & REPEAT_MASK;
 }
 
 }

//*----------------------------------------------------------------------------
//  drcken Taste lesen
//*----------------------------------------------------------------------------

uint8_t get_key_press( uint8_t key_mask )
{
  
  cli();					// read and clear atomic !
  key_mask &= key_press;                        // read key(s)
  key_press ^= key_mask;                        // clear key(s)
  sei();
  return key_mask;
}
 
 //*----------------------------------------------------------------------------
//  wiederholung/repeat Taste lesen
//*----------------------------------------------------------------------------

uint8_t get_key_rpt( uint8_t key_mask )
{
  cli();					// read and clear atomic !
  key_mask &= key_rpt;                        	// read key(s)
  key_rpt ^= key_mask;                        	// clear key(s)
  sei();
  return key_mask;

}
 
//*----------------------------------------------------------------------------
// Taste ffnen lesen
//*----------------------------------------------------------------------------
 
uint8_t get_key_short( uint8_t key_mask )
{
  cli();			// read key state and key press atomic !
  return get_key_press( ~key_state & key_mask );
}
 
//*----------------------------------------------------------------------------
// Taste lang drcken lesen
//*----------------------------------------------------------------------------
 
uint8_t get_key_long( uint8_t key_mask )
{
  return get_key_press( get_key_rpt( key_mask ));
}
 
 

